    001    /* ===========================================================
    002     * JFreeChart : a free chart library for the Java(tm) platform
    003     * ===========================================================
    004     *
    005     * (C) Copyright 2000-2007, by Object Refinery Limited and Contributors.
    006     *
    007     * Project Info:  http://www.jfree.org/jfreechart/index.html
    008     *
    009     * This library is free software; you can redistribute it and/or modify it
    010     * under the terms of the GNU Lesser General Public License as published by
    011     * the Free Software Foundation; either version 2.1 of the License, or
    012     * (at your option) any later version.
    013     *
    014     * This library is distributed in the hope that it will be useful, but
    015     * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
    016     * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
    017     * License for more details.
    018     *
    019     * You should have received a copy of the GNU Lesser General Public
    020     * License along with this library; if not, write to the Free Software
    021     * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301,
    022     * USA.
    023     *
    024     * [Java is a trademark or registered trademark of Sun Microsystems, Inc.
    025     * in the United States and other countries.]
    026     *
    027     * -------------------------------------
    028     * IntervalCategoryToolTipGenerator.java
    029     * -------------------------------------
    030     * (C) Copyright 2004, 2007, by Object Refinery Limited.
    031     *
    032     * Original Author:  David Gilbert (for Object Refinery Limited);
    033     * Contributor(s):   -;
    034     *
    035     * Changes
    036     * -------
    037     * 11-May-2004 : Version 1, split from IntervalCategoryItemLabelGenerator (DG);
    038     *
    039     */
    040
    041    package org.jfree.chart.labels;
    042
    043    import java.io.Serializable;
    044    import java.text.DateFormat;
    045    import java.text.NumberFormat;
    046
    047    import org.jfree.data.category.CategoryDataset;
    048    import org.jfree.data.category.IntervalCategoryDataset;
    049    import org.jfree.util.PublicCloneable;
    050
    051    /**
    052     * A tooltip generator for plots that use data from an
    053     * {@link IntervalCategoryDataset}.
    054     */
    055    public class IntervalCategoryToolTipGenerator
    056        extends StandardCategoryToolTipGenerator
    057        implements CategoryToolTipGenerator, PublicCloneable, Cloneable,
    058                   Serializable {
    059
    060        /** For serialization. */
    061        private static final long serialVersionUID = -3853824986520333437L;
    062
    063        /** The default format string. */
    064        public static final String DEFAULT_TOOL_TIP_FORMAT_STRING
    065            = "({0}, {1}) = {3} - {4}";
    066
    067        /**
    068         * Creates a new generator with a default number formatter.
    069         */
    070        public IntervalCategoryToolTipGenerator() {
    071            super(DEFAULT_TOOL_TIP_FORMAT_STRING, NumberFormat.getInstance());
    072        }
    073
    074        /**
    075         * Creates a new generator with the specified number formatter.
    076         *
    077         * @param labelFormat  the label format string (<code>null</code> not
    078         *                     permitted).
    079         * @param formatter  the number formatter (<code>null</code> not permitted).
    080         */
    081        public IntervalCategoryToolTipGenerator(String labelFormat,
    082                                                NumberFormat formatter) {
    083            super(labelFormat, formatter);
    084        }
    085
    086        /**
    087         * Creates a new generator with the specified date formatter.
    088         *
    089         * @param labelFormat  the label format string (<code>null</code> not
    090         *                     permitted).
    091         * @param formatter  the date formatter (<code>null</code> not permitted).
    092         */
    093        public IntervalCategoryToolTipGenerator(String labelFormat,
    094                                                DateFormat formatter) {
    095            super(labelFormat, formatter);
    096        }
    097
    098        /**
    099         * Creates the array of items that can be passed to the
    100         * <code>MessageFormat</code> class for creating labels.
    101         *
    102         * @param dataset  the dataset (<code>null</code> not permitted).
    103         * @param row  the row index (zero-based).
    104         * @param column  the column index (zero-based).
    105         *
    106         * @return The items (never <code>null</code>).
    107         */
    108        protected Object[] createItemArray(CategoryDataset dataset,
    109                                           int row, int column) {
    110            Object[] result = new Object[5];
    111            result[0] = dataset.getRowKey(row).toString();
    112            result[1] = dataset.getColumnKey(column).toString();
    113            Number value = dataset.getValue(row, column);
    114            if (getNumberFormat() != null) {
    115                result[2] = getNumberFormat().format(value);
    116            }
    117            else if (getDateFormat() != null) {
    118                result[2] = getDateFormat().format(value);
    119            }
    120
    121            if (dataset instanceof IntervalCategoryDataset) {
    122                IntervalCategoryDataset icd = (IntervalCategoryDataset) dataset;
    123                Number start = icd.getStartValue(row, column);
    124                Number end = icd.getEndValue(row, column);
    125                if (getNumberFormat() != null) {
    126                    result[3] = getNumberFormat().format(start);
    127                    result[4] = getNumberFormat().format(end);
    128                }
    129                else if (getDateFormat() != null) {
    130                    result[3] = getDateFormat().format(start);
    131                    result[4] = getDateFormat().format(end);
    132                }
    133            }
    134            return result;
    135        }
    136
    137    }